﻿Imports System.IO
Imports FarPoint.Win.Spread.DrawingSpace
Imports GrapeCity.Spreadsheet
Imports GrapeCity.Spreadsheet.Drawing

Public Class Form1
    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        FpSpread1.Features.EnhancedShapeEngine = True
        FpSpread1.Features.RichClipboard = True
        Using s As MemoryStream = New MemoryStream(My.Resources.ExcelTemplate.car_repair_excel)
            FpSpread1.OpenExcel(s, FarPoint.Excel.ExcelOpenFlags.DocumentCaching)
        End Using
        FpSpread1.ActiveSheet.RowCount = 43
        Dim workbook As IWorkbook = FpSpread1.AsWorkbook()
        For n As Integer = 0 To workbook.ActiveSheet.Shapes.Count - 1
            Dim shape As IShape = workbook.ActiveSheet.Shapes(n)
            shape.CanMove = FarPoint.Win.Spread.DrawingSpace.Moving.None
            shape.CanRotate = False
            shape.CanSize = FarPoint.Win.Spread.DrawingSpace.Sizing.None
            If shape.Name = "Picture 2" Then
                Continue For
            End If
            AddHandler shape.Action, AddressOf Shape_Action
        Next n
        BindProperties()
    End Sub

    Private Sub BindProperties()
        Dim workbook As IWorkbook = FpSpread1.AsWorkbook()
        Dim shapes As IShapes = workbook.Worksheets(0).Shapes
        ' bind shape properties to cells
        shapes("Front").Bindings.Add("Left", "Sheet2!B2")
        shapes("Front").Bindings.Add("Top", "Sheet2!C2")
        shapes("Front").Bindings.Add("Width", "Sheet2!D2")
        shapes("Front").Bindings.Add("Height", "Sheet2!E2")
        shapes("Front").Bindings.Add("Line", "Sheet2!F2")
        shapes("Hood").Bindings.Add("Left", "Sheet2!B3")
        shapes("Hood").Bindings.Add("Top", "Sheet2!C3")
        shapes("Hood").Bindings.Add("Width", "Sheet2!D3")
        shapes("Hood").Bindings.Add("Height", "Sheet2!E3")
        shapes("Hood").Bindings.Add("Line", "Sheet2!F3")
        shapes("FrontWindshield").Bindings.Add("Left", "Sheet2!B4")
        shapes("FrontWindshield").Bindings.Add("Top", "Sheet2!C4")
        shapes("FrontWindshield").Bindings.Add("Width", "Sheet2!D4")
        shapes("FrontWindshield").Bindings.Add("Height", "Sheet2!E4")
        shapes("FrontWindshield").Bindings.Add("Line", "Sheet2!F4")
        shapes("Roof").Bindings.Add("Left", "Sheet2!B5")
        shapes("Roof").Bindings.Add("Top", "Sheet2!C5")
        shapes("Roof").Bindings.Add("Width", "Sheet2!D5")
        shapes("Roof").Bindings.Add("Height", "Sheet2!E5")
        shapes("Roof").Bindings.Add("Line", "Sheet2!F5")
        shapes("RearTop").Bindings.Add("Left", "Sheet2!B6")
        shapes("RearTop").Bindings.Add("Top", "Sheet2!C6")
        shapes("RearTop").Bindings.Add("Width", "Sheet2!D6")
        shapes("RearTop").Bindings.Add("Height", "Sheet2!E6")
        shapes("RearTop").Bindings.Add("Line", "Sheet2!F6")
        shapes("Rear").Bindings.Add("Left", "Sheet2!B7")
        shapes("Rear").Bindings.Add("Top", "Sheet2!C7")
        shapes("Rear").Bindings.Add("Width", "Sheet2!D7")
        shapes("Rear").Bindings.Add("Height", "Sheet2!E7")
        shapes("Rear").Bindings.Add("Line", "Sheet2!F7")
        shapes("LeftFront").Bindings.Add("Left", "Sheet2!B8")
        shapes("LeftFront").Bindings.Add("Top", "Sheet2!C8")
        shapes("LeftFront").Bindings.Add("Width", "Sheet2!D8")
        shapes("LeftFront").Bindings.Add("Height", "Sheet2!E8")
        shapes("LeftFront").Bindings.Add("Line", "Sheet2!F8")
        shapes("LeftFrontDoor").Bindings.Add("Left", "Sheet2!B9")
        shapes("LeftFrontDoor").Bindings.Add("Top", "Sheet2!C9")
        shapes("LeftFrontDoor").Bindings.Add("Width", "Sheet2!D9")
        shapes("LeftFrontDoor").Bindings.Add("Height", "Sheet2!E9")
        shapes("LeftFrontDoor").Bindings.Add("Line", "Sheet2!F9")
        shapes("LeftBackDoor").Bindings.Add("Left", "Sheet2!B10")
        shapes("LeftBackDoor").Bindings.Add("Top", "Sheet2!C10")
        shapes("LeftBackDoor").Bindings.Add("Width", "Sheet2!D10")
        shapes("LeftBackDoor").Bindings.Add("Height", "Sheet2!E10")
        shapes("LeftBackDoor").Bindings.Add("Line", "Sheet2!F10")
        shapes("LeftBack").Bindings.Add("Left", "Sheet2!B11")
        shapes("LeftBack").Bindings.Add("Top", "Sheet2!C11")
        shapes("LeftBack").Bindings.Add("Width", "Sheet2!D11")
        shapes("LeftBack").Bindings.Add("Height", "Sheet2!E11")
        shapes("LeftBack").Bindings.Add("Line", "Sheet2!F11")
        shapes("RightFront").Bindings.Add("Left", "Sheet2!B12")
        shapes("RightFront").Bindings.Add("Top", "Sheet2!C12")
        shapes("RightFront").Bindings.Add("Width", "Sheet2!D12")
        shapes("RightFront").Bindings.Add("Height", "Sheet2!E12")
        shapes("RightFront").Bindings.Add("Line", "Sheet2!F12")
        shapes("RightFrontDoor").Bindings.Add("Left", "Sheet2!B13")
        shapes("RightFrontDoor").Bindings.Add("Top", "Sheet2!C13")
        shapes("RightFrontDoor").Bindings.Add("Width", "Sheet2!D13")
        shapes("RightFrontDoor").Bindings.Add("Height", "Sheet2!E13")
        shapes("RightFrontDoor").Bindings.Add("Line", "Sheet2!F13")
        shapes("RightBackDoor").Bindings.Add("Left", "Sheet2!B14")
        shapes("RightBackDoor").Bindings.Add("Top", "Sheet2!C14")
        shapes("RightBackDoor").Bindings.Add("Width", "Sheet2!D14")
        shapes("RightBackDoor").Bindings.Add("Height", "Sheet2!E14")
        shapes("RightBackDoor").Bindings.Add("Line", "Sheet2!F14")
        shapes("RightBack").Bindings.Add("Left", "Sheet2!B15")
        shapes("RightBack").Bindings.Add("Top", "Sheet2!C15")
        shapes("RightBack").Bindings.Add("Width", "Sheet2!D15")
        shapes("RightBack").Bindings.Add("Height", "Sheet2!E15")
        shapes("RightBack").Bindings.Add("Line", "Sheet2!F15")
    End Sub

    Private Sub Shape_Action(ByVal sender As Object, ByVal e As Drawing.ShapeEventArgs)
        Dim workbook As IWorkbook = FpSpread1.AsWorkbook()
        Dim worksheet As IWorksheet = workbook.ActiveSheet
        Dim shapes As IShapes = worksheet.Shapes
        If Not IsNothing(e.Shape) Then
            Dim name As String = e.Shape.Name
            If e.Shape.Fill.Transparency = 0.99 Then
                e.Shape.Fill.Transparency = 0.5
                If name = "Front" Or name = "Rear" Then shapes("BumperDamage").Fill.Transparency = 0.5
                If name = "Roof" Then shapes("RoofDamage").Fill.Transparency = 0.5
                If name = "RoofDamage" Then shapes("Roof").Fill.Transparency = 0.5
                If name = "HighSeverity" Or name = "MediumSeverity" Or name = "LowSeverity" Then
                    shapes("HighSeverity").Fill.Transparency = 0.99
                    shapes("MediumSeverity").Fill.Transparency = 0.99
                    shapes("LowSeverity").Fill.Transparency = 0.99
                    shapes(name).Fill.Transparency = 0.5
                End If
            Else
                e.Shape.Fill.Transparency = 0.99
                If name = "Front" And shapes("Rear").Fill.Transparency = 0.99 Then shapes("BumperDamage").Fill.Transparency = 0.99
                If name = "Rear" And shapes("Front").Fill.Transparency = 0.99 Then shapes("BumperDamage").Fill.Transparency = 0.99
                If name = "Roof" Then shapes("RoofDamage").Fill.Transparency = 0.99
                If name = "RoofDamage" Then shapes("Roof").Fill.Transparency = 0.99
            End If
        End If
    End Sub

    Private Sub SaveToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SaveToolStripMenuItem.Click
        Dim d As New SaveFileDialog
        d.Filter = "Excel Macro-enabled Workbook (*.XLSM)|*.XLSM"
        d.FilterIndex = 0
        d.Title = "Save File"
        If d.ShowDialog() = DialogResult.OK Then
            FpSpread1.SaveExcel(d.FileName, FarPoint.Excel.ExcelSaveFlags.DocumentCaching Or FarPoint.Excel.ExcelSaveFlags.UseOOXMLFormat)
        End If
    End Sub

    Private Sub ExitToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ExitToolStripMenuItem.Click
        Close()
    End Sub

End Class
